# Makefile - Common definitions for building PIC32 deployment payloads
#
# Copyright (C) 2015, 2017, 2018 Paul Boddie <paul@boddie.org.uk>
# Copyright (C) Xiangfu Liu <xiangfu@sharism.cc>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

ARCH = mipsel-linux-gnu
CC = $(ARCH)-gcc
LD = $(ARCH)-ld
NM = $(ARCH)-nm
OBJCOPY=$(ARCH)-objcopy
OBJDUMP=$(ARCH)-objdump

# These paths are relative to each example directory.

INCDIR = ../../include
LIBDIR = ../../lib

# NOTE: -O2 is actually needed to prevent memcpy references, whereas probably
# NOTE: one of the -f{freestanding, no-hosted, no-builtin} options should work.
# NOTE: See: https://gcc.gnu.org/bugzilla/show_bug.cgi?id=56888

CFLAGS = -O2 -Wall \
	-fno-unit-at-a-time -fno-zero-initialized-in-bss \
	-ffreestanding -fno-hosted -fno-builtin \
	-march=mips32 \
	-I. \
	-I$(INCDIR)
LDFLAGS = -nostdlib -EL

# Ordering of objects is important and cannot be left to replacement rules.

START_SRC = $(LIBDIR)/start.S
START_OBJ = $(LIBDIR)/start.o

# Application-specific files appear after the above but before those below in
# the application Makefiles.

COMMON_SRC = $(LIBDIR)/init.c $(LIBDIR)/debug.c $(LIBDIR)/cpu.S
COMMON_OBJ = $(LIBDIR)/init.o $(LIBDIR)/debug.o $(LIBDIR)/cpu.o

DISPLAY_SRC = $(LIBDIR)/display.c $(LIBDIR)/vga_display.c
DISPLAY_OBJ = $(LIBDIR)/display.o $(LIBDIR)/vga_display.o

# Common linker script.

SCRIPT = $(LIBDIR)/payload.ld
